﻿//returns index of first inclusion of obj_in, else -1
function array_indexOf(array_in, obj_in) {
  var index_out = -1;
  if (array_in != null)
   for (var index=0; index < array_in.length; index++)
     if (array_in[index] == obj_in) {
       index_out = index;
       break;
     }
  return(index_out);
}

// walk through all childnodes of node_in, calling callback function on each node
function dom_childnodes_walk(node_in, callback) {
  if (node_in) {
    callback(node_in); // call callback function on each non-empty child
    if (node_in.childNodes)
      for (var child in node_in.childNodes) // recursive walk all subnodes
        dom_childnodes_walk(node_in.childNodes[child], callback);
  }
}

//deletes all children of given node
function dom_childnodes_delete(node_in, condition) {
  if (condition == undefined) condition = 'true';
  while(node_in.childNodes.length > 0)
    if (eval(condition)) node_in.removeChild(node_in.firstChild);
}

//parse string URL, read existent parameters present in associative array params_in to it
function url_to_params(url_in, params_in) {
  var params_out = {};
  if (params_in) params_out = params_in;
  var url_tmp = url_in; // create copy of url
  if (url_tmp) {
    url_tmp = decodeURIComponent(url_tmp); // unescape URL characters
    if (url_tmp.indexOf('?') != -1) url_tmp = url_tmp.split('?')[1]; // leave characters after '?'
    if (url_tmp.indexOf('#') != -1) url_tmp = url_tmp.split('#')[0]; // leave characters before '#'
    var pars = url_tmp.split('&'); // split string by individual parameters (delimited by '&')
    for (var parn=0; parn < pars.length; parn++) {
      var par = pars[parn].split('='); // split parameter string to name and value
      if (par.length == 2) params_out[par[0]] = par[1];
    }
  }
  return params_out;
}

//build and return URL parameters string from associative array params
function params_to_url(params_in) {
  var url_out = ''; // result
  for (var param_name in params_in) url_out += param_name + '=' + String(params_in[param_name]) + '&';
  return url_out.slice(0, -1); // remove ending '&'
}

//transform - lean given element, width_perc - used percent of block width, div_off_class - class name of hiding blocks
function div_lean(elem, width_perc, steps_num, div_off_class) {
  if (elem) {
    var lean_left = false;
    if (width_perc < 0) {
      width_perc = -width_perc;
      lean_left = true;
    }
    var pw = elem.clientWidth, ph = elem.clientHeight;
    var step_width = (100.0 - width_perc) / (steps_num - 1); // step width, percent from div width
    var step_height = 100.0 / steps_num; // step height, percent from div height
    for (var step_side=0; step_side<=1; step_side++)
     for (var step_cnt=0; step_cnt<steps_num; step_cnt++) {
      var step_div = document.createElement('span');
      if (div_off_class != undefined) step_div.className = div_off_class;
      step_div.style.position = 'absolute';
      step_div.style.backgroundColor = elem.parentNode.style.backgroundColor;
      if (step_side==0) step_div.style.left = '0%'; else step_div.style.left = (width_perc + (step_cnt * step_width)) + '%';
      if (lean_left) step_div.style.top = (100.0 - ((step_cnt + 1.0) * step_height)) + '%';
                else step_div.style.top = (step_cnt * step_height) + '%';
      step_div.style.height = step_height + '%';
      if (step_side==0) step_div.style.width = (step_cnt * step_width) + '%'; else step_div.style.width = ((steps_num - step_cnt - 1.0) * step_width) + '%';
      elem.appendChild(step_div);
     }
  }
}

// global onload function - calls every ul.onload function
function global_onload() {
  if (ul.onload)
    for (onload_fun in ul.onload)
      ul.onload[onload_fun]();
}

// add event function name and event name prefix
var add_event_func = 'addEventListener';
var event_name_prefix = '';
// add event function special for IE
if (document.all) {add_event_func = 'attachEvent'; event_name_prefix = 'on';}

// create global configuration
if (!ul) var ul = {};
ul.params = url_to_params(window.location.search);
ul.onload = [];

// attach main onload handler
window.onload = global_onload;
